setup_test
-require_prog script
-
-actual="$MH_TEST_DIR/test-version-check$$.actual"
+actual="${MH_TEST_DIR}/test-version-check$$.actual"
context="${MH_TEST_DIR}"/Mail/context
version="Version: nmh-${MH_VERSION}"
+cmd="${MH_TEST_DIR}/Mail/cmd"
+runpty="${MH_OBJ_DIR}/test/runpty"
+
+#### Run a command but don't wait for user input. We switched from script(1)
+#### to our own utility, runpty. Check that it makes the command look like
+#### it's connected to a terminal below.
+run_without_input() {
+ #### Create a command to use as a shell for script.
+ cat >"${cmd}" <<EOF
+#! /bin/sh
+$*
+EOF
+ chmod +x "${cmd}"
+
+ "$runpty" "${actual}" "${cmd}"
+}
+
+#### Ensure that runpty makes the program look like it's connected to a
+#### terminal. The welcome message code in sbr/utils.c needs that.
+run_without_input 'if test -t 0 -a -t 1 -a -t 2; then echo tty; fi'
+grep tty "${actual}" >/dev/null || test_skip "runpty doesn't simulate tty"
+
# Removing Version will trigger the welcome message. (setup_test
# inserted it so that other tests wouldn't show it.)
-grep -v Version "$context" > "$context.NEW"
-mv -f "$context.NEW" "$context"
+grep -v Version "${context}" > "${context}.NEW"
+mv -f "${context}.NEW" "${context}"
start_test 'mhparam skips the welcome message'
-# The command will wait for the user to hit return. script seems to do what
-# we want by not waiting when run in the background.
-script -c 'mhparam path last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
-rm "$actual"
+run_without_input mhparam path
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# Make sure that version wasn't added to context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null && false
-finish_test
+rm "${actual}"
start_test 'Welcome: disable in profile skips the welcome message'
cp "${MH}" "${MH}-welcome"
printf 'Welcome: disable\n' >> "${MH}-welcome"
-MH="${MH}-welcome" script -c 'pick last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
-rm "$actual"
+# Run the function in subshell instead of augmenting the environment
+# for a single command, so that the environment does not retain the
+# MH setting. That can happen when run under distcheck, depending
+# on the user's shell.
+(MH="${MH}-welcome"; run_without_input pick last)
+rm "${MH}-welcome"
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# Make sure that version wasn't added to context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null && false
-finish_test
+rm "${actual}"
start_test 'with welcome message'
-script -c 'pick last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null
-rm "$actual"
+run_without_input pick last
+grep 'Welcome to nmh version ' "${actual}" >/dev/null
# Make sure that version was added to context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null
-finish_test
+rm "${actual}"
start_test 'without welcome message'
# After running the previous test, this one should not have
# the welcome message.
-script -c 'pick last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
-rm "$actual"
+run_without_input pick last
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# Make sure that version is still in context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null
-finish_test
+rm "${actual}"
start_test 'with MHCONTEXT, welcome only if older'
MHCONTEXT="${MH_TEST_DIR}/Mail/context2"; export MHCONTEXT
printf 'Version: nmh-1.5\n' >"${MHCONTEXT}"
-script -c 'pick last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null
+run_without_input pick last
+grep 'Welcome to nmh version ' "${actual}" >/dev/null
# And make sure that version did get updated in context.
grep "^${version}$" "${MHCONTEXT}" >/dev/null
-rm "$actual"
-finish_test
+rm "${actual}"
start_test "with MHCONTEXT doesn't welcome if newer"
printf 'Version: nmh-10000.0\n' >"${MHCONTEXT}"
-script -c 'pick last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
-rm "$actual"
+run_without_input pick last
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# And make sure that version didn't get updated in context.
grep '^Version: nmh-10000.0$' "${MHCONTEXT}" >/dev/null
-finish_test
+rm "${actual}"
start_test 'with MHCONTEXT but no version, no welcome and update'
printf '' >"${MHCONTEXT}"
-script -c 'pick last' -f -q "$actual" >/dev/null &
-wait $!
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
+run_without_input pick last
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# And make sure that version did get updated in context.
grep "^${version}$" "${MHCONTEXT}" >/dev/null
-rm "$actual"
-finish_test
+rm "${actual}"
-exit $failed
+finish_test
+exit ${failed}